/* Multiple versions of memcpy. AARCH64 version.
   Copyright (C) 2017-2019 Free Software Foundation, Inc.
   This file is part of the GNU C Library.

   The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or (at your option) any later version.

   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with the GNU C Library; if not, see
   <http://www.gnu.org/licenses/>.  */

/* Define multiple versions only for the definition in libc.  */
# include <string.h>
# include <init-arch.h>

extern __typeof (mesa_memcpy) mesa_memcpy_align_128 attribute_hidden;
extern __typeof (mesa_memcpy) mesa_memcpy_align_64 attribute_hidden;

extern __typeof (mesa_memmove) mesa_memmove_align_128 attribute_hidden;
extern __typeof (mesa_memmove) mesa_memmove_align_64 attribute_hidden;

extern __typeof (mesa_memset) mesa_memset_align_128 attribute_hidden;
extern __typeof (mesa_memset) mesa_memset_align_64 attribute_hidden;

libc_ifunc (mesa_memcpy,
            (!midr || IS_FT1500A (midr)
	     ? mesa_memcpy_align_64
	     : ((IS_FT2000AHK (midr) || IS_FTS5000C(midr))
		 ? mesa_memcpy_align_128
		 : memcpy)))

libc_ifunc (mesa_memmove,
            (!midr || IS_FT1500A (midr)
	     ? mesa_memmove_align_64
	     : ((IS_FT2000AHK (midr) || IS_FTS5000C(midr))
		 ? mesa_memmove_align_128
		 : memmove)))

libc_ifunc (mesa_memset,
            (!midr || IS_FT1500A (midr)
	     ? mesa_memset_align_64
	     : ((IS_FT2000AHK (midr) || IS_FTS5000C(midr))
		 ? mesa_memset_align_128
		 : memset)))
